### Définition de contraintes sur les attributs

#### Définition d’un attribut dans l’arbre

Le nœud **Attributs** contient tous les attributs d’un type d’entité.

![](../../Ressources/Images/menu_contextuel_attributs.PNG)

La fonction **Ajouter un attribut** permet de créer un nouvel attribut. Lors du clic sur cet élément du menu, un nouvel attribut est ajouté à la liste et la fenêtre de création de l’attribut est affichée.


**Activer tous les attributs** et **Désactiver tous les attributs** permettent respectivement d’activer et de désactiver la vérification de tous les attributs lors d’un contrôle. L’activation ou la désactivation de l’attribut peut être gérée individuellement au niveau de chaque attribut.

##### Formulaire des caractéristiques de l’attribut

Ce formulaire permet de définir les attributs du type d’entité à contrôler. Chaque attribut est associé à un type d’entité et à chacun correspondent des contraintes spécifiques.

![](../../Ressources/Images/attribut.png)

###### Valeur obligatoire

La case **Valeur obligatoire** permet de spécifier si la valeur de l’attribut est obligatoire ou optionnelle.

<span style="color: #943a99">==> Erreur retournée : E0009 (Violation de contrainte de non nullité).</span>.

###### Type d’attributs 

Le champs **Type** permet de vérifier le type de l’attribut :
* Alphanumérique : tous les caractères, qu'ils soient numériques (0-9) ou lettres (a-z,  A-Z). Les espaces, nuls, codes de contrôle, ponctuation et caractères accentués ou étendus ne sont pas inclus;
* Flottant : valeur décimale;
* Entier : nombre entier positif ou négatif;
* Booléen : les valeurs booléennes valides sont les chaînes de caractères TRUE, True, true, 1, FALSE, False, false, 0;
* Chaîne de caractères.

<span style="color: #943a99;">==> Erreur retournée : E0043 (Type d’attribut non conforme).</span>.

###### Longueur d’attribut

L’utilisateur peut définir la **longueur** maximale de la chaîne de caractère de l’attribut.

<span style="color: #943a99;">==> Erreur retournée : E0007 (Taille de l’attribut trop grande).</span>.

###### Expression régulière

Le groupement **Expression Régulière** permet de définir le motif d’une expression régulière (En savoir plus sur les [Expressions régulières](../../04-ContraintesRessources/05.01.DefinirContraintesREGEX.html) et obtenir des exemples). L'utilisateur peut soit saisir son expression, soit utiliser une expression prédéfinie dans la liste déroulante. Il peut également modifier la liste, en cliquant sur le bouton <big style="font-weight: bold;">+</big>.

<span style="color: #943a99;">==> Erreur retournée : E0012 (Valeur d’attribut hors expression régulière).</span>.

###### Valeur numérique min et max

Les champs **Min** et **Max** permettent de définir les plages de valeurs de l’attribut.

<span style="color: #943a99;">==> Erreurs retournées : E0039 (Valeur d’attribut inférieure au minimum).</span>

<span style="color: #943a99;">==> Erreurs retournées : E0040 (Valeur d’attribut supérieure au maximum).</span>

###### Date

Le groupement **Formats de date** permet de spécifier la structure du format souhaité pour les dates. On peut saisir un format personnalisé ou utiliser un format prédéfini dans la liste déroulante. La liste peut être éditée en cliquant sur le bouton <big style="font-weight: bold;">+</big>.

<span style="color: #943a99;">==> Erreur retournée : E0034 (Date non conforme).</span>

![](../../Ressources/Images/Interface_format_date_685x189.png)

L’utilisateur peut saisir des constantes et insérer des directives dans la structure même de la date. Dans l’exemple ci-dessus, pour le format _Le ’jour de la semaine’ puis jj/mm/dd_, ’Le %a,%d/%m/%y’ retournera la date sous la forme : Le lundi, 20/04/20.

[En savoir plus sur les directives Python de définition de date.](../../04-ContraintesRessources/05.02.FormatsDate.html)

##### Domaine de valeurs

Le **Domaine de valeurs** est un terme utilisé dans les SGBD pour indiquer une liste de valeurs autorisées pour une colonne particulière d’une table.

L’utilisateur peut sélectionner le domaine de valeurs que peut prendre l’attribut. Les domaines sont directement éditables en cliquant sur le bouton <big style="font-weight: bold;">+</big>. La fenêtre d’édition de domaines s’affiche :

![](../../Ressources/Images/domaine_valeur.png)

Nommer le domaine et définir les valeurs soit en entrant une expression régulière dans le champs **Expression**, soit en cliquant sur le bouton ![](../../Ressources/Images/bouton.png) qui ouvre la fenêtre d’édition des valeurs d’un domaine.

![](../../Ressources/Images/domaine.png)

![](../../Ressources/Images/attention.png) Des valeurs issues de fichiers externes peuvent être directement importées par copier/coller. Après avoir copier les valeurs à importer (dans un fichier Excel par exemple), se positionner sur la première cellule de la fenêtre des domaine puis cliquer sur Coller.

<span style="color: #943a99;">==> Erreur retournée : E0010 (Valeur d’attribut hors domaine).</span>

###### Contraintes spécifiques sur l’attribut

Le groupement **Contrainte spécifique sur l’attribut** permet de définir des contraintes plus complexes sur un attribut.

L’utilisateur peut choisir d’intégrer une contrainte défini dans le langage Python. Les fonctions permettent de vérifier la cohérence entre différents attributs. Par exemple, on peut vérifier : attribut A = 1 si attribut B = "Bois" et attribut A = 2 si attribut B = "Forêt".

<span style="color: #943a99;">==> Erreur retournée : E0047 (Valeur d’attribut hors expression régulière décrite par code python).</span>
[En savoir plus sur les différents langages de définition de contraintes spécifiques](../../04-ContraintesRessources/04.LangagesDefinition.html).

##### Production de Statistiques

Plusieurs types de statistiques peuvent être générés concernant : 
*   les données numériques, 
*   les chaînes de caractères,
*   les domaines,
*   les types d’entité.

##### Menu contextuel d’un attribut

![](../../Ressources/Images/attribut_menu_contextuel.png)

###### Dupliquer

La fonction Dupliquer permet de copier un attribut dans un nouveau type d’entité du même schéma ou d’un autre. Après avoir sélectionné Dupliquer, indiquer le schéma et le type d’entité cible :

![](../../Ressources/Images/duplication_attribut.png)

#### Définition d’attribut dans la liste

En cliquant dans l’arbre sur le nœud **Type d’entité** d’un schéma ![](../../Ressources/Images/clic_TE.png), la liste des types d’entité composant le schéma s’affiche dans la fenêtre de droite. La liste permet de visualiser tous les types d’entité et les contraintes définies. L’onglet Attributs de la liste permet d’afficher la liste de tous les attributs des types d’entité du schéma en cours.

![](../../Ressources/Images/liste_attributs.png)

Les contraintes relatives aux attributs sont visibles d’un simple coup d’œil.

Depuis la liste, il est facilement possible d’éditer, de filtrer, de supprimer et de copier un attribut.
